package task2;

/**
 * A minimal (regular) BST. You can only insert values in this BST.
 */
public class BinarySearchTree {
  protected Node root;

  /**
   * Insert a value in this BST.
   *
   * @param data value to be inserted. Pre: data != null.
   */
  public void insert(int data) {
    root = insert(root, data);
  }

  // Recursive insert
  private Node insert(Node node, int data) {
    if (node == null) {
      return new Node(data);
    } else if (node.data > data) {
      node.left = insert(node.left, data);
    } else if (node.data < data) {
      node.right = insert(node.right, data);
    }
    return node;
  }

  /**
   * Prints out the values in this BST.
   */
  public void traverse() {
    moodyTraversal(root);
  }

  // A recursive traversal with a touch of randomness!
  protected void moodyTraversal(Node node) {
    System.out.print(node);
    // TODO Implement me
  }

  protected static class Node {
    int data;
    Node left;
    Node right;

    Node(int data) {
      this.data = data;
    }

    @Override
    public String toString() {
      return data + " ";
    }
  }
}
